//http://www.i2cdevlib.com/forums/topic/95-invensense-motiondriver-source-code/
//https://github.com/Ferrocen/MPU-9150
PImage TextureAttitudeIndicatorRollDial;
PImage TextureAttitudeIndicatorFacePanel;
PImage TextureAttitudeIndicatorHorizonBar;
PImage TextureAttitudeIndicatorHorizonFlat;

void loadTextureAttitudeIndicator() {
  TextureAttitudeIndicatorRollDial = loadImage("attitude_indicator_roll_dial.png");
  TextureAttitudeIndicatorFacePanel = loadImage("attitude_indicator_face_panel.png");
  TextureAttitudeIndicatorHorizonBar= loadImage("attitude_indicator_horizon_bar.png");
  TextureAttitudeIndicatorHorizonFlat = loadImage("attitude_indicator_horizon_flat.png");
}

void drawAttitudeIndicator(float rotateZ, float moveX) {
  int cDetail =  10;  // Circle detalization
    
  // draw textured Attitude Indicator's Horizon Flat
  pushMatrix();
    drawAttitudeIndicatorHorizonFlat();
  popMatrix();

  // draw textured Attitude Indicator's Horizon Bar
  pushMatrix();
    drawAttitudeIndicatorHorizonBar(rotateZ, moveX);
  popMatrix();
    
  // draw textured Attitude Indicator's Rotating Roll Dial
  pushMatrix();
    drawAttitudeIndicatorRollDial(80, 330, rotateZ);
  popMatrix();
    
  // draw textured Attitude Indicator's Panel
  pushMatrix();
    drawAttitudeIndicatorFacePanel();
  popMatrix();
}

void drawAttitudeIndicatorRollDial(int cDetail, float r, float rotateDial) {
  beginShape();
    noStroke();
    textureMode(NORMAL);
    rotateZ(rotateDial);
    texture(TextureAttitudeIndicatorRollDial);
    float theta = TWO_PI / cDetail;
    for (int i=0; i<cDetail; i++) {
      float angle = theta * i;
      float x = cos(angle);
      float y = sin(angle);
      vertex(x * r, y * r, (x+1)/2, (y+1)/2);
    }
  endShape();
}

void drawAttitudeIndicatorFacePanel() {
  beginShape();
    noStroke();
    textureMode(IMAGE);
    texture(TextureAttitudeIndicatorFacePanel);
    vertex(-394, -394, 0, 0);
    vertex(394, -394, 788, 0);
    vertex(394, 394, 788, 788);
    vertex(-394, 394, 0, 788);
  endShape();
}

void drawAttitudeIndicatorHorizonFlat() {
  beginShape();
    noStroke();
    textureMode(IMAGE);
    texture(TextureAttitudeIndicatorHorizonFlat);
    vertex(-330, -330, 0, 0);
    vertex(330, -330, 660, 0);
    vertex(330, 330, 660, 660);
    vertex(-330, 330, 0, 660);
  endShape();
}

void drawAttitudeIndicatorHorizonBar(float rotateBar, float moveBar) {
  float newX = map(moveBar, -1, 1, -150, 150);
  
  beginShape();
    noStroke();
    textureMode(IMAGE);  
    rotateZ(rotateBar);
    translate(0, newX);
    texture(TextureAttitudeIndicatorHorizonBar);
    vertex(-264, -164, 0, 0);
    vertex(264, -164, 528, 0);
    vertex(264, 164, 528, 328);
    vertex(-264, 164, 0, 328);
  endShape();
}