//http://www.i2cdevlib.com/forums/topic/95-invensense-motiondriver-source-code/
//https://github.com/Ferrocen/MPU-9150
PImage TextureDirectionalGyroRollDial;
PImage TextureDirectionalGyroFacePanel;

void loadTextureDirectionalGyro() {
  TextureDirectionalGyroRollDial = loadImage("directional_gyro_roll_dial.png");
  TextureDirectionalGyroFacePanel = loadImage("directional_gyro_face_panel.png");
}

void drawDirectionalGyro(float rotateZ) {
  int cDetail =  10;  // Circle detalization
  
  // draw textured Directional Gyro's Rotating Roll Dial
  pushMatrix();
    drawDirectionalGyroRollDial(80, 310, rotateZ);
  popMatrix();
  
  // draw textured Directional Gyro's Horizon Flat
  pushMatrix();
    drawDirectionalGyroFacePanel();
  popMatrix();
}

void drawDirectionalGyroFacePanel() {
  beginShape();
    noStroke();
    textureMode(IMAGE);
    texture(TextureDirectionalGyroFacePanel);
    vertex(-394, -394, 0, 0);
    vertex(394, -394, 788, 0);
    vertex(394, 394, 788, 788);
    vertex(-394, 394, 0, 788);
  endShape();
}

void drawDirectionalGyroRollDial(int cDetail, float r, float rotateDial) {
  beginShape();
    noStroke();
    textureMode(NORMAL);
    rotateZ(rotateDial);
    texture(TextureDirectionalGyroRollDial);
    float theta = TWO_PI / cDetail;
    for (int i=0; i<cDetail; i++) {
      float angle = theta * i;
      float x = cos(angle);
      float y = sin(angle);
      vertex(x * r, y * r, (x+1)/2, (y+1)/2);
    }
  endShape();
}