#include "stdafx.h"
#include "windows.h"

DCB dcb;
BOOL fSuccess;
COMMTIMEOUTS CommTimeouts;
std::ofstream filehandler;
//char portIn[16];
//LPCWSTR pcCommPort;
HANDLE hCom;
char Byte = '0';
DWORD dwBytesTransferred;
unsigned long int TimeIn, TimeOut;
unsigned short counter = 0;//min 0 ... max 255
char string[100];
int rawAccX, rawAccY, rawAccZ, rawGyrX, rawGyrY, rawGyrZ, UT, UP, rawTmp, rawXmag, rawYmag, rawZmag;
//Adjust this according to setMagGain function in MikroC
const double hmc5883_Gauss_LSB_XY = 1100.;
const double hmc5883_Gauss_LSB_Z = 980.;
double XmagF, YmagF, ZmagF, heading;
double TempBMP085 = 0.;
double PresBMP085 = 0.;
double AltitudeBMP085 = 0.;
const double PI = 3.1415926535897932384626433832795;
const double RAD2DEG = 180. / PI;
int AccXCal, AccYCal, AccZCal, TmpCal, GyrXCal, GyrYCal, GyrZCal;
double gyrXrate, gyrYrate;// , gyrXangle, gyrYangle;
BOOL sefteto = TRUE;

void initCOMPort(void) {

	if (hCom == INVALID_HANDLE_VALUE) {
		printf("Cannot open serial port first!\n"); getc(stdin);
		return;
	}//if

	//Build on the current configuration, and skip setting the size of the input and output buffers with SetupComm.
	fSuccess = GetCommState(hCom, &dcb);
	if (!fSuccess) {
		printf("Cannot open serial port second!\n"); getc(stdin);
		return;
	}//if

	//if (!GetCommTimeouts(hCom, &ComTo))  return 0; //get timeouts error
	fSuccess = GetCommTimeouts(hCom, &CommTimeouts);
	if (!fSuccess) {
		printf("Cannot open serial port third!\n"); getc(stdin);
		return;
	}//if
	//dcbc = dcb; ComToc = ComTo;

	//Fill in DCB: 9600 bps, 8 data bits, no parity, and 1 stop bit.
	dcb.BaudRate = CBR_57600;  //CBR_115200;//set the baud rate
	dcb.ByteSize = 8;         //data size, xmit, and rcv
	dcb.Parity = NOPARITY;  //no parity bit
	dcb.StopBits = ONESTOPBIT;//one stop bit
	dcb.fBinary = 1;                               //binary mode
	dcb.fDtrControl = DTR_CONTROL_DISABLE;         //clear DTR
	dcb.fRtsControl = RTS_CONTROL_ENABLE;          //set RTS

	fSuccess = SetCommState(hCom, &dcb);
	if (!fSuccess) {
		printf("Cannot open serial port fourth!\n"); getc(stdin);
		return;
	}//if

	fSuccess = SetupComm(hCom, 512, 512);
	if (!fSuccess) {
		printf("Cannot open serial port fifth!\n"); getc(stdin);
		return;
	}//if

	CommTimeouts.ReadIntervalTimeout = 4000;// 100;
	CommTimeouts.ReadTotalTimeoutMultiplier = 0;
	CommTimeouts.ReadTotalTimeoutConstant = 4000;
	CommTimeouts.WriteTotalTimeoutConstant = 4000;// 0;
	CommTimeouts.WriteTotalTimeoutMultiplier = 0;

	fSuccess = SetCommTimeouts(hCom, &CommTimeouts);
	if (!fSuccess) {
		printf("Cannot open serial port sixth!\n"); getc(stdin);
		return;
	}//if

	PurgeComm(hCom, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);

	return;
}

void readHMC5883L(void) {

	XmagF = (double)rawXmag / hmc5883_Gauss_LSB_XY;
	ZmagF = (double)rawZmag / hmc5883_Gauss_LSB_Z;
	YmagF = (double)rawYmag / hmc5883_Gauss_LSB_XY;

	XmagF *= 100.;//SENSORS_GAUSS_TO_MICROTESLA;
	ZmagF *= 100.;
	YmagF *= 100.;

	heading = atan2(YmagF, XmagF);
	//Magnetic declination at Sofia 4*38' = 0,08086692200907060373079767227331 rad
	//h_ttp://www.magnetic-declination.com/
	heading += 0.0809;
	if (heading < 0.) heading += 2.0 * PI;
	if (heading > 2.0 * PI) heading -= 2.0 * PI;

	heading *= RAD2DEG;

	return;
}

void readBMP085(void) {
	signed int AC6, AC5, MC, MD;
	signed long int AC1, AC2, AC3, AC4, B5, B6, X1, X2, X3, B3, B1, B2, p;
	unsigned long int B4, B7;

	AC6 = 19326;
	AC5 = 25562;
	MC = -11075;
	MD = 2432;

	X1 = ((signed long int)UT - (signed long int)AC6) * ((signed long int)AC5) >> 15;
	X2 = ((signed long int)MC << 11) / (X1 + (signed long int)MD);
	B5 = X1 + X2;

	TempBMP085 = 0.1 * ((double)((B5 + 8) >> 4));

	AC1 = 8721;
	AC2 = -1208;
	AC3 = -14420;
	AC4 = 34273;
	B1 = 5498;
	B2 = 65;

	B6 = B5 - 4000;//-1600, almost OK
	X1 = (B2 * ((B6 * B6) >> 12)) >> 11;
	X2 = (AC2 * B6) >> 11;
	X3 = X1 + X2;
	B3 = ((AC1 * 4 + X3) + 2) >> 2;

	X1 = (AC3 * B6) >> 13;
	X2 = (B1 * ((B6 * B6) >> 12)) >> 16;
	X3 = ((X1 + X2) + 2) >> 2;
	B4 = ((unsigned long int)AC4 * (unsigned long int)(X3 + 32768)) >> 15;
	B7 = ((unsigned long int)UP - B3) * 50000;

	if (B7 < 0x80000000) p = (B7 * 2) / B4;
	else p = (B7 / B4) << 1;
	X1 = (p >> 8) * (p >> 8);
	X1 = (X1 * 3038) >> 16;
	X2 = (-7357 * p) >> 16;

	p += (X1 + X2 + 3791) >> 4;
	PresBMP085 = (double)p;

	AltitudeBMP085 = 44330. * (1. - pow(PresBMP085 / 101325., 0.1903));

	return;
}

void CallibrateMPU6050raw(void) {
	unsigned short i, N;

	//Mandatory
	//gyrXangle = 0.; gyrYangle = 0.;// gyrZangle = 0.;

	N = 100;//0 ... 255

	AccXCal = 0; AccYCal = 0; AccZCal = 0;
	TmpCal = 0;
	GyrXCal = 0; GyrYCal = 0; GyrZCal = 0;

	i = 0;
	while (i < N) {
		AccXCal += (int)(rawAccX / (int)N);
		AccYCal += (int)(rawAccY / (int)N);
		AccZCal += (int)(rawAccZ / (int)N);
		TmpCal += (int)(rawTmp / (int)N);
		GyrXCal += (int)(rawGyrX / (int)N);
		GyrYCal += (int)(rawGyrY / (int)N);
		GyrZCal += (int)(rawGyrZ / (int)N);
		i++;
	}//while_i

	AccZCal -= 15595; // Measured offset value

	return;
}

#define RESTRICT_PITCH
double roll, pitch;

void initialProcessing(void) {
	double axD, ayD, azD;

	axD = (double)rawAccX / 16384.;
	ayD = (double)rawAccY / 16384.;
	azD = (double)rawAccZ / 16384.;

	gyrXrate = rawGyrX / 131.; // Convert to deg/s
	gyrYrate = rawGyrY / 131.; // Convert to deg/s

#ifdef RESTRICT_PITCH
	roll = atan2(ayD, azD) * RAD2DEG;
	pitch = atan(-axD / sqrt(ayD * ayD + azD * azD)) * RAD2DEG;
#else 
	roll = atan(ayD / sqrt(axD * axD + azD * azD)) * RAD2DEG;
	pitch = atan2(-axD, azD) * RAD2DEG;
#endif

	return;
}

//http://blog.tkjelectronics.dk/2012/09/a-practical-approach-to-kalman-filter-and-how-to-implement-it/comment-page-6/#comment-556716

typedef struct Kalman {
	/* Kalman filter variables */
	double Q_angle; // Process noise variance for the accelerometer
	double Q_bias; // Process noise variance for the gyro bias
	double R_measure; // Measurement noise variance - this is actually the variance of the measurement noise

	double angle; // The angle calculated by the Kalman filter - part of the 2x1 state vector
	double bias; // The gyro bias calculated by the Kalman filter - part of the 2x1 state vector
	double rate; // Unbiased rate calculated from the rate and the calculated bias - you have to call getAngle to update the rate

	double P[2][2]; // Error covariance matrix - This is a 2x2 matrix
	double K[2]; // Kalman gain - This is a 2x1 vector
	double y; // Angle difference
	double S; // Estimate error
} classT;

void constructorClassT(classT* pThis) {
	/* We will set the variables like so, these can also be tuned by the user */
	pThis->Q_angle = 0.001;
	pThis->Q_bias = 0.003;
	pThis->R_measure = 0.03;

	pThis->angle = 0.;   // Reset the angle
	pThis->bias = 0.;    // Reset bias

	pThis->P[0][0] = 0.; // Since we assume that the bias is 0 and we know the starting angle (use setAngle), the error covariance matrix is set like so
	pThis->P[0][1] = 0.;
	pThis->P[1][0] = 0.;
	pThis->P[1][1] = 0.;

	return;
}

double getAngle(classT* pThis, double newAngle, double newRate, double dt) {

	/* Step 1 */
	pThis->rate = newRate - pThis->bias;
	pThis->angle += dt * pThis->rate;

	// Update estimation error covariance - Project the error covariance ahead
	/* Step 2 */
	pThis->P[0][0] += dt * (dt * pThis->P[1][1] - pThis->P[0][1] - pThis->P[1][0] + pThis->Q_angle);
	pThis->P[0][1] -= dt * pThis->P[1][1];
	pThis->P[1][0] -= dt * pThis->P[1][1];
	pThis->P[1][1] += pThis->Q_bias * dt;

	// Discrete Kalman filter measurement update equations - Measurement Update ("Correct")
	// Calculate Kalman gain - Compute the Kalman gain
	/* Step 4 */
	pThis->S = pThis->P[0][0] + pThis->R_measure;

	/* Step 5 */
	pThis->K[0] = pThis->P[0][0] / pThis->S;
	pThis->K[1] = pThis->P[1][0] / pThis->S;

	// Calculate angle and bias - Update estimate with measurement zk (newAngle)
	/* Step 3 */
	pThis->y = newAngle - pThis->angle;

	/* Step 6 */
	pThis->angle += pThis->K[0] * pThis->y;
	pThis->bias += pThis->K[1] * pThis->y;

	// Calculate estimation error covariance - Update the error covariance
	/* Step 7 */
	pThis->P[0][0] -= pThis->K[0] * pThis->P[0][0];
	pThis->P[0][1] -= pThis->K[0] * pThis->P[0][1];
	pThis->P[1][0] -= pThis->K[1] * pThis->P[0][0];
	pThis->P[1][1] -= pThis->K[1] * pThis->P[0][1];

	return pThis->angle;
}//getAngle

void setAngle(classT* pThis, double newAngle) {

	pThis->angle = newAngle;

	return;
} // Used to set angle, this should be set as the starting angle

double getRate(classT* pThis) { return pThis->rate; } // Return the unbiased rate
/* These are used to tune the Kalman filter */
void setQangle(classT* pThis, double newQ_angle) { pThis->Q_angle = newQ_angle; return; }
void setQbias(classT* pThis, double newQ_bias) { pThis->Q_bias = newQ_bias; return; }
void setRmeasure(classT* pThis, double newR_measure) { pThis->R_measure = newR_measure; return; }

double getQangle(classT* pThis) { return pThis->Q_angle; }
double getQbias(classT* pThis) { return pThis->Q_bias; }
double getRmeasure(classT* pThis) { return pThis->R_measure; }

classT kalmanX, kalmanY;
double dt = 0.001;

void readCOMPort(void) {
	double kalAngleX, kalAngleY;

	ReadFile(hCom, &Byte, 1, &dwBytesTransferred, 0);
	if (Byte != 0x1F) filehandler << Byte;
	else filehandler << " ";
	string[counter] = Byte;
	//std::cout << Byte;//to delete
	counter++;
	if (Byte == 0x1F) {

		//std::cout << " " << std::endl;//to delete
		string[counter - 1] = '\0';
		counter = 0;

		rawAccX = atoi(&string[0]);
		rawAccY = atoi(&string[7]);
		rawAccZ = atoi(&string[14]);

		rawGyrX = atoi(&string[21]);
		rawGyrY = atoi(&string[28]);
		rawGyrZ = atoi(&string[35]);

		rawTmp = atoi(&string[42]);
		UT = atoi(&string[49]);
		UP = atoi(&string[56]);

		rawXmag = atoi(&string[63]);
		rawYmag = atoi(&string[70]);
		rawZmag = atoi(&string[77]);

		if (sefteto) {
			sefteto = FALSE;
			TimeIn = GetTickCount();
			CallibrateMPU6050raw();
			//std::cout << AccXCal << " " << AccYCal << " " << AccZCal << " " << TmpCal << " " << GyrXCal << " " << GyrYCal << " " << GyrZCal << std::endl;
			initialProcessing();
			setAngle(&kalmanX, pitch); // Set starting angle
			setAngle(&kalmanY, roll);
		}//if_sefteto

		//std::cout << rawAccX << " " << rawAccY << " " << rawAccZ << " " << rawGyrX << " " << rawGyrY << " " << rawGyrZ << " " << rawTmp << " " << UT << " " << UP << " " << rawXmag << " " << rawYmag << " " << rawZmag << " " << dt << std::endl;
		//std::cout << (rawTmp / 340. + 36.53) << std::endl;
		//std::cout << UT << " " << UP << std::endl;//to delete

		readHMC5883L();
		readBMP085();
		std::cout << TempBMP085 << " " << PresBMP085 << " " << AltitudeBMP085 << " " << heading << std::endl;

		initialProcessing();
		setAngle(&kalmanX, pitch);
		setAngle(&kalmanY, roll);

		TimeOut = GetTickCount();
		dt = (double)(TimeOut - TimeIn) / 1000.;

		kalAngleX = getAngle(&kalmanX, pitch, gyrYrate, dt);
		kalAngleY = getAngle(&kalmanY, roll, gyrXrate, dt);

		filehandler << dt << std::endl;

		//std::cout << dt << " " << kalAngleX << " " << kalAngleY << std::endl;

		TimeIn = GetTickCount();

	}//if

	return;
}

int _tmain(int argc, _TCHAR* argv[]) {
	LPCWSTR pcCommPort = argv[1];

	constructorClassT(&kalmanX);
	constructorClassT(&kalmanY);

	//    sprintf(portIn, "com3\0");
	//    pcCommPort = (LPCWSTR) portIn;
	hCom = CreateFile(pcCommPort, GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 0, NULL);

	initCOMPort();

	filehandler.open("dataout.txt");
	if (!filehandler.is_open()) { std::cout << "Can't open file for writing!" << std::endl; return 0; }

	//Start sampling
	WriteFile(hCom, "e", 1, &dwBytesTransferred, 0);
	WriteFile(hCom, "s", 1, &dwBytesTransferred, 0);

	for (;;) {
		readCOMPort();
	}//for

	//Unreachable code unless for loop is finite
	filehandler.close();
	//Stop sampling
	WriteFile(hCom, "e", 1, &dwBytesTransferred, 0);
	CloseHandle(hCom);

	return 0;
}
