#include <HMC5883L.h>

const int HMC5883L = 0x3C; //write address
//const float rad2deg = 180.0 / 3.1415926535897932384626433832795;

static float hmc5883_Gauss_LSB_XY = 1100.0f;  // Varies with gain
static float hmc5883_Gauss_LSB_Z  = 980.0f;   // Varies with gain

//float XmagF, YmagF, ZmagF;
//signed int Xmag, Ymag, Zmag;

void setMagGain(unsigned short gain) {

     // Set gain
     I2C1_Start();
     I2C1_Wr(HMC5883L & 0xFE);
     I2C1_Wr(0x01);
     //I2C1_Wr(HMC5883_MAGGAIN_1_3);
     I2C1_Wr(gain);
     I2C1_Stop();

     switch(gain) {
     case HMC5883_MAGGAIN_1_3:
          hmc5883_Gauss_LSB_XY = 1100.;
          hmc5883_Gauss_LSB_Z  = 980.;
     break;
     case HMC5883_MAGGAIN_1_9:
          hmc5883_Gauss_LSB_XY = 855.;
          hmc5883_Gauss_LSB_Z  = 760.;
     break;
     case HMC5883_MAGGAIN_2_5:
          hmc5883_Gauss_LSB_XY = 670.;
          hmc5883_Gauss_LSB_Z  = 600.;
     break;
     case HMC5883_MAGGAIN_4_0:
          hmc5883_Gauss_LSB_XY = 450.;
          hmc5883_Gauss_LSB_Z  = 400.;
     break;
     case HMC5883_MAGGAIN_4_7:
          hmc5883_Gauss_LSB_XY = 400.;
          hmc5883_Gauss_LSB_Z  = 255.;
     break;
     case HMC5883_MAGGAIN_5_6:
          hmc5883_Gauss_LSB_XY = 330.;
          hmc5883_Gauss_LSB_Z  = 295.;
     break;
     case HMC5883_MAGGAIN_8_1:
          hmc5883_Gauss_LSB_XY = 230.;
          hmc5883_Gauss_LSB_Z  = 205.;
     break;
     }//switch

     return;
}

void initHMC5883L(void) {

     I2C1_Start();
     I2C1_Wr(HMC5883L & 0xFE);
     I2C1_Wr(0x02);
     I2C1_Wr(0x00); //Continuous measurement mode (0x01);
     I2C1_Stop();
     
     setMagGain(HMC5883_MAGGAIN_1_3);

     return;
}

void readHMC5883Lraw(void) {

     I2C1_Start();             // Issue start signal
     I2C1_Wr(HMC5883L & 0xFE); // Address + Write bit
     I2C1_Wr(0x03);
     I2C1_Repeated_Start();
     I2C1_Wr(HMC5883L | 0x01); // Address + Read bit
     Xmag = I2C1_Rd(1u) << 8 | I2C1_Rd(1u);
     Zmag = I2C1_Rd(1u) << 8 | I2C1_Rd(1u);
     Ymag = I2C1_Rd(1u) << 8 | I2C1_Rd(0u); // Not acknowledge
     I2C1_Stop();

     return;
}
